"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.borderWidth = exports.borderTop = exports.borderRight = exports.borderRadius = exports.borderLeft = exports.borderColor = exports.borderBottom = exports.border = void 0;
var _tokenTypes = require("../tokenTypes");
var _util = require("./util");
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var WORD = _tokenTypes.tokens.WORD,
  FUNC = _tokenTypes.tokens.FUNC,
  COLOR = _tokenTypes.tokens.COLOR,
  LENGTH = _tokenTypes.tokens.LENGTH,
  UNSUPPORTED_LENGTH_UNIT = _tokenTypes.tokens.UNSUPPORTED_LENGTH_UNIT;
function borderDirectionFactory() {
  var direction = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var prefix = "border".concat(direction);
  return (0, _util.anyOrderFactory)(_defineProperty(_defineProperty(_defineProperty({}, "".concat(prefix, "Width"), {
    tokens: [LENGTH, UNSUPPORTED_LENGTH_UNIT],
    "default": 1
  }), "".concat(prefix, "Color"), {
    tokens: [COLOR],
    "default": 'black'
  }), "borderStyle", {
    tokens: [(0, _tokenTypes.regExpToken)(/^(solid|dashed|dotted)$/)],
    "default": 'solid'
  }));
}
var border = exports.border = borderDirectionFactory();
var borderTop = exports.borderTop = borderDirectionFactory('Top');
var borderRight = exports.borderRight = borderDirectionFactory('Right');
var borderBottom = exports.borderBottom = borderDirectionFactory('Bottom');
var borderLeft = exports.borderLeft = borderDirectionFactory('Left');
var borderColor = exports.borderColor = (0, _util.directionFactory)({
  types: [WORD, FUNC],
  prefix: 'border',
  suffix: 'Color'
});
var borderRadius = exports.borderRadius = (0, _util.directionFactory)({
  directions: ['TopLeft', 'TopRight', 'BottomRight', 'BottomLeft'],
  prefix: 'border',
  suffix: 'Radius'
});
var borderWidth = exports.borderWidth = (0, _util.directionFactory)({
  prefix: 'border',
  suffix: 'Width'
});